<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BookTable StructType
 * @subpackage Structs
 */
class BookTable extends AbstractStructBase
{
    /**
     * The xmldata
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $xmldata;
    /**
     * Constructor method for BookTable
     * @uses BookTable::setXmldata()
     * @param string $xmldata
     */
    public function __construct($xmldata = null)
    {
        $this
            ->setXmldata($xmldata);
    }
    /**
     * Get xmldata value
     * @return string|null
     */
    public function getXmldata()
    {
        return $this->xmldata;
    }
    /**
     * Set xmldata value
     * @param string $xmldata
     * @return \StructType\BookTable
     */
    public function setXmldata($xmldata = null)
    {
        // validation for constraint: string
        if (!is_null($xmldata) && !is_string($xmldata)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($xmldata)), __LINE__);
        }
        $this->xmldata = $xmldata;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BookTable
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
